class ReadLineAdapter(object):
    BUFFER_SIZE = 65536

    def __init__(self, fh):
        self.__fh = fh
        self.__buffer = ""

    def readline(self):
        lfpos = self.__buffer.find("\n")
        while lfpos == -1 and self.__fh:
            checked = len(self.__buffer)
            chunk = self.__fh.read(self.BUFFER_SIZE)
            if chunk == "":
                self.__fh = None
                ret = self.__buffer
                self.__buffer = ""
                return ret
            self.__buffer += chunk
            lfpos = self.__buffer.find("\n", checked)

        part = self.__buffer[:lfpos+1]
        self.__buffer = self.__buffer[lfpos+1:]
        return part

    def read(self, size = None):
        if size == None:
            while self.__fh:
                chunk = self.__fh.read(self.BUFFER_SIZE)
                if chunk == "":
                    self.__fh = None
                self.__buffer += chunk

            part = self.__buffer
            self.__buffer = ""
            return part

        if len(self.__buffer) < size:
            toread = size - len(self.__buffer)
            toread = (toread + self.BUFFER_SIZE - 1) / self.BUFFER_SIZE * self.BUFFER_SIZE
            if self.__fh:
                chunk = self.__fh.read(toread)
                if chunk == "":
                    self.__fh = None
                self.__buffer += chunk

        part = self.__buffer[:size]
        self.__buffer = self.__buffer[size:]
        return part

    def close(self):
        if self.__fh:
            self.__fh.close()
